import clamd

from nicevirus.backends.base import BaseBackend


class ClamAVBackend(BaseBackend):
    def __init__(self, config):
        self.config = config

        self.clamd = clamd.ClamdUnixSocket(config.get('socket_path', '/tmp/clamd.socket'))
        assert self.clamd.ping() == 'PONG', 'Failed to ping clamd socket'

    def check(self):
        return self.clamd.ping() == 'PONG'

    def scan(self, path):
        found, name = self.clamd.scan(path)[path]
        return {
            'found': False if found == 'OK' else True,
            'metadata': {
                'name': name
            }
        }
